package drawing;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.util.Random;

/**
 * Classe abstraite de type forme dessinable.
 */
public abstract class Shape {
	static int LEFT = 1;
	static int RIGHT = 2;
	static int UP = 3;
	static int DOWN = 4;
	
	static Random r = new Random();
	
	protected Point origin;
	protected Color color;
	protected int velocity;
	int hDirection;
	int vDirection;


	public Shape(Point origin, Color color, int velocity)
	{
		this.origin = origin;
		this.color = color;
		this.velocity = velocity;
		this.hDirection = r.nextInt(2)+1;
		this.vDirection = r.nextInt(2)+3;
	}
	
	public void setOrigin(Point p)
	{
		origin = p;
	}
	
	public abstract boolean touchLine(java.awt.Point p1, java.awt.Point p2);
	 
	public void move(java.awt.Rectangle bounds)
	{
		/*TODO : cette methode est beaucoup trop longue
		 *       et naive. Il faut la rimplementer et la 
		 *       factoriser pour qu'elle fasse au maximum 
		 *       8 lignes.
		*/
		Point topLeft, topRight, bottomLeft, bottomRight;
		
		topLeft =  new Point(bounds.x, bounds.y);
		topRight = new Point(bounds.x + bounds.width, bounds.y);
		
		bottomLeft =  new Point(bounds.x, bounds.y + bounds.height);
		bottomRight = new Point(bounds.x + bounds.width, bounds.y + bounds.height);

		if(this.touchLine(topLeft, topRight)){
			this.vDirection = Shape.DOWN;
			this.hDirection = r.nextInt(2)+1;
		}
		else if(this.touchLine(bottomLeft, bottomRight)){
			this.vDirection = Shape.UP;
			this.hDirection = r.nextInt(2)+1;
		}
		
		if(this.touchLine(topLeft, bottomLeft)){
			this.hDirection = Shape.RIGHT;
			this.vDirection = r.nextInt(2)+3;
		}
		else if(this.touchLine(topRight, bottomRight)){
			this.hDirection = Shape.LEFT;
			this.vDirection = r.nextInt(2)+3;
		}
		
		
		if(hDirection == LEFT)
		{
			origin.x = origin.x - velocity;
		}
		else if(hDirection == RIGHT)
		{
			origin.x = origin.x + velocity;
		}
		
		if(vDirection == UP)
		{
			origin.y = origin.y - velocity;
		}
		else if(vDirection == DOWN)
		{
			origin.y = origin.y + velocity;
		}
	}
	
	/**
	 * dessine la forme sur un Graphics
	 */
	public abstract void paint(Graphics g);
	
	/**
	 * renvoie true si la forme occupe sur le point donn
	 */
	public abstract boolean isOn(Point p);
}
